VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "MenuHelp Demo"
   ClientHeight    =   2325
   ClientLeft      =   2025
   ClientTop       =   5235
   ClientWidth     =   5265
   ClipControls    =   0   'False
   Height          =   3015
   KeyPreview      =   -1  'True
   Left            =   1965
   LinkTopic       =   "Form1"
   ScaleHeight     =   2325
   ScaleWidth      =   5265
   Top             =   4605
   Width           =   5385
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      ClipControls    =   0   'False
      Height          =   1005
      Left            =   2760
      ScaleHeight     =   945
      ScaleWidth      =   2235
      TabIndex        =   4
      Top             =   930
      Width           =   2295
   End
   Begin VB.Timer tmrExample4 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   3600
      Top             =   180
   End
   Begin VB.OptionButton optExample 
      Caption         =   "Example 4"
      Enabled         =   0   'False
      Height          =   225
      Index           =   4
      Left            =   360
      TabIndex        =   3
      Top             =   1710
      Width           =   2055
   End
   Begin VB.OptionButton optExample 
      Caption         =   "Example 3"
      Height          =   225
      Index           =   3
      Left            =   360
      TabIndex        =   2
      Top             =   1440
      Width           =   2055
   End
   Begin VB.OptionButton optExample 
      Caption         =   "Example 2"
      Height          =   225
      Index           =   2
      Left            =   360
      TabIndex        =   1
      Top             =   1200
      Width           =   2055
   End
   Begin VB.OptionButton optExample 
      Caption         =   "Example 1"
      Height          =   225
      Index           =   1
      Left            =   360
      TabIndex        =   0
      Top             =   960
      Width           =   2055
   End
   Begin MsghookLib.Msghook Msghook1 
      Left            =   4560
      Top             =   150
      _Version        =   65536
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
   End
   Begin VB.Menu menu1 
      Caption         =   "menu&1"
      Begin VB.Menu menu1a 
         Caption         =   "menu1a"
      End
      Begin VB.Menu menu1b 
         Caption         =   "menu1b"
         Begin VB.Menu menu1b1 
            Caption         =   "menu1b1"
         End
         Begin VB.Menu menu1b2 
            Caption         =   "menu1b2"
         End
      End
      Begin VB.Menu menu1c 
         Caption         =   "menu1c"
      End
   End
   Begin VB.Menu menu2 
      Caption         =   "menu2"
      Begin VB.Menu menu2a 
         Caption         =   "menu2a"
         Begin VB.Menu menu2a1 
            Caption         =   "menu2a1"
         End
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

' Happily brought to you by:
'   Brad Martinez
'   btmtz@msn.com
'   btmtz@aol.com
'   http://members.aol.com/btmtz/vb

' ============================================

' MenuHelp:  Contains four examples demonstrating different
'                   methods of placing helpful text in a status bar.

' Example 1: The hard way to use the MenuHelp function.
' Example 2: The easy way to use the MenuHelp function.
' Example 3: Why even bother with the MenuHelp function?
' Example 4: Since we don't need the MenuHelp function, why
'                   bother with subclassing...?

' ==============================================
' Overview:

' The initial intent of this demo was to only document and explain
' how to use the poorly documented MenuHelp API function.
' But after finishing the first two examples, which I hope provide
' some clarity as to the use of the function, I decided to take
' things a couple of steps further.

' Example 3 shows how to programmatically replace all of the
' functionality MenuHelp offers by sending the appropriate
' messages to the status bar as well as how to extract and
' display the system submenu help strings yourself.

' Example 4 goes all out. As well as not using the MenuHelp
' function, it successfully eliminates any need to detect the
' WM_MENUSELECT window message in order to display
' the correct help string for selected menu items. This example
' is very much a novelty...

' ==============================================
' Technical info:

' This demo was created using VB4-32. Examples 1-3 employ
' the services of Mayby Software's MsgHook subclassing
' control to catch the WM_MENUSELECT message, providing
' assistance in displaying help strings on a status bar. The
' control must be properly registered on the system this demo
' is run on.

' MsgHoo32.ocx can be registered either by running the included
' file "reghook.bat" or by loading it into any VB project though VB's
' Tools | Custom Controls dialog.

' Of course in VB5, the AddressOf operator would obviously be
' used in conjunction with a user-defined window procedure to
' replace MsgHook's Msghook1_Message procedure below.

' ==============================================
' What you need to know:

' Knowledge of intercepting and handling window messages is
' definately assumed.

' A general knowledge of the creation and use of resource files
' is also expected.

' Before continuing, a review is suggested of the values returned
' by the WM_MENUSELECT window message and the MenuHelp
' function itself, both in found in this project's MenuHelp.bas file.
' Take your time with MenuHelp. Even with documention, it's
' behavior can be initially difficult to understand.

' Also, a status bar common control is dynamically created below
' in the Form_Load() procedure and is used by each example
' discussed. Various status bar specific messages are sent to it
' throughout the four examples which may appear unfamiliar. All
' of the status bar's definitions can be found in this project's
' Status.bas file. For a complete demonstration of the behavior
' of the status bar and it's associated messages, download the
' file Status.zip found at the URL above.

' ==============================================
' Resource IDs and menu command IDs:

' Because of VB's inherent menu limitations (or features), this
' demo is a somewhat more involved implementation of the
' MenuHelp function than is necessary. If we were able to
' assign our own ID to each menu command, the values could
' be passed directly to MenuHelp and things would be much
' easier. But since this isn't possible, a scheme must be
' established to dynamically obtain each menu command's
' string resource ID from the resource file and then pass this
' value to the MenuHelp function. See the included file
' "VBCmdIDs.txt for more information.

' The key to making all of the examples succeed is the correct
' alignment of each menu item's string resource ID and it's
' relative menu structure position. Each example explains
' how it deals with this situation.

' ==============================================
' Let's go...
 

Private Sub Form_Load()
  
  Dim adwParts(1) As Long
    
  ' Setup the subclaasing proc using the Msghook ctrl.
  Msghook1.HwndHook = hwnd
  ' MenuHelp just needs to see the WM_MENUSELECT msg
  Msghook1.Message(WM_MENUSELECT) = True
  
  ' Initialize Comctl32.dll
  InitComctl32 ICC_BAR_CLASSES
  
  ' Create a generic status bar...
  g_hStatBar = CreateStatusWindow(SBARS_SIZEGRIP Or _
                                                       WS_VISIBLE Or _
                                                       WS_CHILD, _
                                                       vbNullString, hwnd, 0)
  ' You never know...
  If g_hStatBar = 0 Then MsgBox "go figure...": Unload Me
  
  ' Add 2 "parts" (aka Comctl32.ocx "Panel"s).
  ' The 2nd part extends the width of the status bar.
  adwParts(0) = 250: adwParts(1) = -1
  SendMessage g_hStatBar, SB_SETPARTS, ByVal 2, adwParts(0)
  
  ' Initialize the display, invokes click
  optExample(1) = True
  
  ' Initialize the first 3 examples' data.
  InitExample1
  InitExample2
  InitExample3
  
  ' Let the demo proceed now just in case things
  ' don't work ouy below...
  Show
  
  ' See the comments at the top of Example4.bas
  ' and in it's GetSysMenuParent() function ...
  optExample(4).Enabled = InitExample4()
    
End Sub

' For some visual appeal...
Private Sub Form_Resize()
  SendMessage g_hStatBar, WM_SIZE, 0, 0
End Sub

' Sets up each example accordingly.

Private Sub optExample_Click(Index As Integer)
  Dim sText As String
  
  Select Case Index
    Case 1
      ShowIDENotice True
      sText = "Uses MenuHelp function w/ VB resource IDs"
      tmrExample4 = False
    Case 2
      ShowIDENotice True
      sText = "Uses MenuHelp function w/ user resource IDs"
      tmrExample4 = False
    Case 3
      ShowIDENotice False
      sText = "No MenuHelp function, uses subclassing"
      tmrExample4 = False
    Case 4
      ShowIDENotice False
      sText = "No MenuHelp function or subclassing, uses Timer"
      tmrExample4 = True
  End Select
  
  ' Place the text in the 1st part of the status bar. The text
  ' will be saved in the 1st part when it's set to simple
  ' mode with the SB_SIMPLE message by each example.
  SendMessage g_hStatBar, _
                        SB_SETTEXT, _
                        ByVal 0 Or SBT_SUNKEN, _
                        ByVal sText
End Sub

Private Sub ShowIDENotice(fShow As Boolean)
  Dim sMePath As String * 260
  
  AutoRedraw = True
  Cls
  If fShow Then
    ' Show the MenuHelp() function notice only if in the IDE...
    GetModuleFileName App.hInstance, sMePath, 260   ' hmmm...
    If InStr(1, sMePath, App.EXEName & ".exe", 1) = 0 Then
      Print " Important note: The MenuHelp function will not display VB resource"
      Print " strings in the status bar while in the VB design-time environment."
      Print " A VB app's stringtable resource is only accessable to MenuHelp"
      Print " in a VB compiled executable. Run MenuHelp.exe"
    End If
  End If
  AutoRedraw = False
  
End Sub

' Here's where it all begins...

' Warning: Do not break execution in this procedure and in any
' of it's called procedures or undesirable behavior may result...

Private Sub Msghook1_Message(ByVal msg As Long, _
                                                ByVal wp As Long, _
                                                ByVal lp As Long, _
                                                result As Long)
  Select Case msg
    Case WM_MENUSELECT
      
      ' Each DoExample procedure called below is Public,
      ' residing in it's own respective Bas module.
      If optExample(1) Then DoExample1 wp, lp
      If optExample(2) Then DoExample2 wp, lp
      If optExample(3) Then DoExample3 wp, lp
  
  End Select

End Sub

Private Sub tmrExample4_Timer()   ' Interval initially set to 100
  DoExample4   ' No MsgHook!
End Sub

Private Sub Form_Unload(Cancel As Integer)
  Msghook1.HwndHook = 0
  Set Form1 = Nothing
  End
End Sub

